#include <stdio.h>

/* Read a TAI64N external format timestamp from stdin and write fractional
   seconds since epoch (TAI, not UTC) to stdout.  Return the character after
   the timestamp. */
int
decode(void)
{
    int c;
    unsigned long u;
    unsigned long seconds = 0;
    unsigned long nanoseconds = 0;

    while ((c = getchar()) != EOF) {
        u = c - '0';
        if (u >= 10) {
            u = c - 'a';
            if (u >= 6) break;
            u += 10;
        }
        seconds <<= 4;
        seconds += nanoseconds >> 28;
        nanoseconds &= 0xfffffff;
        nanoseconds <<= 4;
        nanoseconds += u;
    }
    seconds -= 4611686018427387914ULL;
    printf("%lu.%lu ", seconds, nanoseconds);
    return c;
}


int
main(void)
{
    int c;

    while ((c = getchar()) != EOF) {
        if (c == '@') c = decode();
        while (c != EOF) {
            putchar(c);
            if (c == '\n') break;
            c = getchar();
        }
    }
}

